Loading...
Searching...
No Matches
casacore::BucketBuffered Class Reference
casa package (libcasa_casa) » IO_module

More...

`#include <BucketBuffered.h>`

## Public Member Functions

| BucketBuffered (BucketFile *file, Int64 startOffset, uInt bucketSize, uInt nrOfBuckets)
| Create the object for (part of) a file.
virtual | ~BucketBuffered ()
char * | getBuffer ()
| Get a pointer to the buffer.
void | read (uInt bucketNr, uInt bucketOffset, uInt nbytes, uInt bufferOffset=0)
| Read the given part into the internal buffer at the given offset.
void | write (uInt bucketNr, uInt bucketOffset, uInt nbytes)
| Write the given part from the internal buffer.
Public Member Functions inherited from casacore::BucketBase
| BucketBase (BucketFile *file, Int64 startOffset, uInt bucketSize, uInt nrOfBuckets)
| Create the bucket access for (part of) a file.
virtual | ~BucketBase ()
| Detach the file.
Bool | flush ()
| Flush the cached buckets.
virtual void | resync (uInt nrBucket)
| Resynchronize the object (after another process updated the file).
uInt | nBucket () const
| Get the current nr of buckets in the file.
void | extend (uInt nrBucket)
| Extend the file with the given number of buckets.
void | setWritten ()
| Set that data has been written.

## Private Member Functions

| BucketBuffered (const BucketBuffered &)
| Copy constructor is not possible.
BucketBuffered & | operator= (const BucketBuffered &)
| Assignment is not possible.
virtual void | doFlush ()
| Flush the file.
virtual void | doResync ()
| Do the actual resync-ing.
virtual void | doExtend (uInt nrBucket)
| Extend the file with the given number of buckets.
virtual void | initializeBuckets (uInt bucketNr)
| Initialize the bucket buffer.

## Private Attributes

char * | itsBuffer
| Data buffer.

## Additional Inherited Members

Protected Member Functions inherited from casacore::BucketBase
| BucketBase (const BucketBase &)
| Copy constructor is not possible.
BucketBase & | operator= (const BucketBase &)
| Assignment is not possible.
Protected Attributes inherited from casacore::BucketBase
BucketFile * | itsFile
| The file used.
Int64 | itsStartOffset
| The starting offsets of the buckets in the file.
uInt | itsBucketSize
| The bucket size.
uInt | itsCurNrOfBuckets
| The current nr of buckets in the file.
uInt | itsNewNrOfBuckets
| The new nr of buckets in the file (after extension).
Bool | itsHasWritten
| Have data been written?

## Detailed Description

Use buffered file IO for buckets in a part of a file

### Intended use:

Public interface

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

### Prerequisite

- BucketFile

### Synopsis

BucketBuffered is similar to class BucketCache and is meant to be used by the storage managers of the Table System.

It gives access to buckets in a file by means of memory-buffered files. However, its functionality is a subset of BucketCache and is only meant to be used by the Tiled Storage Managers. If The Standard and Incremental Storage Manager also want to use it, functions like extend needs to be added to this class. Also support for a free bucket list needs to be added.

### Motivation

Use of BucketCache is sub-optimal when having large buckets and more or less random IO. Memory-buffering behaves much better.

Definition at line 73 of file BucketBuffered.h.

## Constructor & Destructor Documentation

## BucketBuffered() [1/2]

casacore::BucketBuffered::BucketBuffered | ( | BucketFile * | file,
|  | Int64 | startOffset,
|  | uInt | bucketSize,
|  | uInt | nrOfBuckets )

Create the object for (part of) a file.

The file part buffered into memory starts at startOffset. Its length is bucketSize*nrOfBuckets bytes. If the file is smaller, the remainder is indicated as an extension similarly to the behaviour of function extend.

Referenced by BucketBuffered(), and operator=().

## ~BucketBuffered()

virtual casacore::BucketBuffered::~BucketBuffered | ( |  | ) |

virtual

## BucketBuffered() [2/2]

casacore::BucketBuffered::BucketBuffered | ( | const BucketBuffered & |  | ) |

private

Copy constructor is not possible.

References BucketBuffered().

## Member Function Documentation

## doExtend()

virtual void casacore::BucketBuffered::doExtend | ( | uInt | nrBucket | ) |

private virtual

Extend the file with the given number of buckets.

Implements casacore::BucketBase.

## doFlush()

virtual void casacore::BucketBuffered::doFlush | ( |  | ) |

private virtual

Flush the file.

Implements casacore::BucketBase.

## doResync()

virtual void casacore::BucketBuffered::doResync | ( |  | ) |

private virtual

Do the actual resync-ing.

Implements casacore::BucketBase.

## getBuffer()

char * casacore::BucketBuffered::getBuffer | ( |  | ) |

inline

Get a pointer to the buffer.

Definition at line 87 of file BucketBuffered.h.

References itsBuffer.

## initializeBuckets()

virtual void casacore::BucketBuffered::initializeBuckets | ( | uInt | bucketNr | ) |

private virtual

Initialize the bucket buffer.

The uninitialized buckets before this bucket are also initialized.

Implements casacore::BucketBase.

## operator=()

BucketBuffered & casacore::BucketBuffered::operator= | ( | const BucketBuffered & |  | ) |

private

Assignment is not possible.

References BucketBuffered().

## read()

void casacore::BucketBuffered::read | ( | uInt | bucketNr,
|  | uInt | bucketOffset,
|  | uInt | nbytes,
|  | uInt | bufferOffset = 0 )

Read the given part into the internal buffer at the given offset.

## write()

void casacore::BucketBuffered::write | ( | uInt | bucketNr,
|  | uInt | bucketOffset,
|  | uInt | nbytes )

Write the given part from the internal buffer.

## Member Data Documentation

## itsBuffer

char* casacore::BucketBuffered::itsBuffer

private

Data buffer.

Definition at line 119 of file BucketBuffered.h.

Referenced by getBuffer().

The documentation for this class was generated from the following file:

- casa/IO/BucketBuffered.h